'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.LayerMethods = undefined;
exports.layerClass = layerClass;
exports.layerObject = layerObject;

var _Layers = require('./Layers.js');

var cop = _interopRequireWildcard(_Layers);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function layerClass(layer, constructor, definitions) {
    return layer.refineClass(constructor, definitions);
} /*
   * Copyright (c) 2008-2011 Hasso Plattner Institute
   *
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
  
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

function layerObject(layer, object, definitions) {
    return layer.refineObject(object, definitions);
}

var LayerMethods = exports.LayerMethods = {
    // you can put these in the Layer class with the following:
    // Object.assign(Layer.prototype, LayerMethods)

    layerClass: function layerClass() {
        return this.refineClass.apply(this, arguments);
    },
    layerObject: function layerObject() {
        return this.refineObject.apply(this, arguments);
    }
};